
var _tb_remove = window.tb_remove;

//Prevent double's in thickbox

var pvgList = {

	listName   : "#pvg_lActionTxt",
	listbttn   : "#pvg_cActionBtn",
	showMsg    : "#pl_message",
	showLists  : "#showLists",
	addtoList  : "[id^=addtoList]",
	removeList : "[id^=rm_list]",
	removeVids : "[id^=rm_video]",
	showList   : "#pvg_slist",
	addtoPage  : "[class^=pvgPages]",  
	listWindow : "[id^=pvg_singlelist]",
	listVideos : "[id^=pvg_videos]",
	editVideos : "[id^=editVideo]",
	updateVids : "[id^=updateSingVid]",

	pvg_updateSVid : function ()
	{
		var t = this;

		jQuery (t.updateVids).on ("click", function () {
			console.log ("updated");
		});
	},

	pvg_editVideos : function ()
	{
		var t = this;

		jQuery (t.editVideos).on ("click", function (e) {
			e.stopImmediatePropagation ();

			var div   = jQuery (this).attr ("name");

			jQuery ("#TB_window").fadeOut ("slow");
			jQuery (t.listVideos).fadeOut ("slow", function (){
				tb_show ("Editing Video", "?TB_inline?&inlineId="+div+"&height=550");
				jQuery ("#TB_window").fadeIn ("slow");
			});
		});
		t.pvg_updateSVid ();
		return false;
	},

	pvg_addToPage : function ()
	{
		var t = this;

		jQuery (t.addtoPage).on ("change", function (e)
		{

			e.stopImmediatePropagation ();

			var loader = jQuery (this).closest ("tr").find (".loaderatp");
			var listID = jQuery (this).closest ("tr")
						 .find (t.removeList).attr ("name");
			var pageID = jQuery (this).val ();

			loader.show ();

			jQuery.ajax ({
				url:   ajaxurl,
				type:  "POST",
				data: {
					listid:  listID,
					pageid:  pageID,
					typekey: "upDatePage",
					action:  "pvg_AjaxRetRequestl",
				}
			}).fail (function (){
			    return false;
			
			}).done (function (data) {

				jQuery (".loaderatp").hide ();
		
				if (data != null && data ['pvgjMSG']["code"] == 0)
				{
					t.pvg_statusMsg (data ['pvgjMSG']["msg"], "success", "#pl_message", 1);
					t.pvg_getList ();
				}
				return false;
			});
		});
	},

	//Add video to list.
	pvg_addtoList : function  ()
	{
		var t = this;

        jQuery(t.addtoList).on ("change", function (e) 
        {
        	e.stopImmediatePropagation ();
        	
        	if (!jQuery(this).val () == "")
        	{
        		var stext  = jQuery(this).children (":selected");
        		var addtxt = jQuery(stext).closest ("tr").find (t.showList);

                jQuery.ajax ({
                    url:  ajaxurl,
                    type: "POST", 
                    cache: false,
                    data: {
                        postCommentNonce: pvgjs.postCommentNonce,
                        action:           "pvg_AjaxRetRequestl",
                        typekey:          "cinVid", 
                        catlist:          jQuery(this).val (),
                        catVid:           jQuery(this).attr ("name"),
                    }
                }).fail (function (){
                    return;

                }).done (function (data){

                	jQuery(this).hide ();
                	
                	if (data == "limite_reached")
                	{
                		jQuery (addtxt).html (
                			"<strong style='color: red'>Private Video</strong>"
                		);

                	}else{
                	
                		jQuery (addtxt).text (stext.text ());
                	}
                	t.pvg_getList ();
                });

            }
        });  

	},

	pvg_statusMsg : function (data, stat, selector, notimer)
	{
		//var t = this;
		var i = 2500;

		if (notimer == null)
		{
			notimer = 0;
		}

		jQuery (selector).removeClass ().addClass ("pvg_message " + stat).
				html (data).fadeIn ("fast");

		if (jQuery (selector).hasClass ("pvg_message") && notimer == 1)
		{
			setTimeout (function (){
				jQuery (selector).removeClass ().html ("");
			}, i);
		}
	},

	//Create list 
	pvg_createList : function ()
	{
		var t = this;

		jQuery(t.listbttn).on ("click", function (e){

			jQuery (".loadercreate").show ();
			
			e.stopImmediatePropagation ();
			
			jQuery.ajax ({
				url:  ajaxurl,
				type: "POST", 
				cache: false,
				data: {
					postCommentNonce: pvgjs.postCommentNonce,
					action: 		  "pvg_AjaxRetRequestl",
					typekey:          "clist", 
					pvg_listname:	  jQuery(t.listName).val (),
				}
			}).fail (function (){

				console.log ("failed");

			}).done (function (data){

				jQuery (".loadercreate").hide ();

				if (data ['pvgjMSG']["code"] > 0)
				{
					t.pvg_statusMsg (data ['pvgjMSG']["msg"], "errors", "#pl_message", 1);

				}else{

					t.pvg_getList ();
					jQuery (".pvg_message").removeClass ().html ("");
					t.pvg_statusMsg (data ['pvgjMSG']["msg"], "success", "#pl_message", 1);
					return false;
				}

			});
		});
	},

	//Remove created list and its videos
	pvg_rmList : function ()
	{
		var t = this;

		jQuery(t.removeList).on ("click", function (e)
		{
			e.stopImmediatePropagation();
			
			//if (jQuery(this).is (":checked"))
			//{
				if (confirm ("Are you sure you wish to delete this list?"))
				{
					jQuery.ajax ({
						url:  ajaxurl,
						type: "POST", 
						cache: false,
						data: {
							postCommentNonce: pvgjs.postCommentNonce,
							action: 		  "pvg_AjaxRetRequestl",
							typekey:          "crmList", 
							rmlist:   		  jQuery(this).attr ("name"),
						}
					}).fail (function (){
						console.log ("failed");

					}).done (function (data){
						t.pvg_getList ();
						t.pvg_statusMsg (data ['pvgjMSG']["msg"], "success", "#pl_message", 1);
						return false;
					});
				}else {
					return false;
				}
			//}
			//e.preventDefault ();
		});
	},

	//Remove added videos from list
	pvg_rmVideos : function ()
	{
		var t = this;

		jQuery(t.removeVids).on ("click", function (e)
		{
			e.stopImmediatePropagation();
	
			var name = jQuery(this).attr ("name");
			
			if (confirm ("Are you sure you wish to delete this Video?"))
			{
				jQuery.ajax ({
					url:  ajaxurl,
					type: "POST", 
					cache: false,
					data: {
						postCommentNonce: pvgjs.postCommentNonce,
						action: 		  "pvg_AjaxRetRequestl",
						typekey:          "crmVideo", 
						rmVideo:   		  jQuery(this).attr ("name"),
					}
				}).fail (function (){
						console.log ("failed");

				}).done (function (data){
					jQuery ("#"+name).fadeOut ("fast");
					return false;
				});
			}else {

				return false;
			}
		}); 
	},

 	//Allow enterkey on textbox
    pvg_EnterKey : function ()
    {
        var t = this;

        jQuery (t.listName).on ("keyup", function (e)
        {
        	e.stopImmediatePropagation ();
        	//e.preventDefault();
        	code = e.keyCode || e.whish;

            if (code == 13) 
            {
                jQuery (t.listbttn).trigger ("click");
                return false;
            }
        });
    },
	//Get created lists
	pvg_getList : function () 
	{
		var t = this;

		jQuery (t.showMsg).each (function (){
			jQuery (this).hide ();
		});

		jQuery.ajax ({
			url:  ajaxurl,
			type: "POST", 
			cache: false,
			data: {
				postCommentNonce: pvgjs.postCommentNonce,
				action: 		  "pvg_AjaxRetRequestl",
				typekey:          "cgetList", 
			}
		}).fail (function (){
			console.log ("failed");

		}).done (function (data){

			if (data ['pvgjMSG'] != null)
			{
				if (data ['pvgjMSG']["code"] >= 1)
				{
					t.pvg_statusMsg (data ['pvgjMSG']["msg"], "warning", ".pvg_srhMsg", 0);
				}
			}

			jQuery (t.showLists).empty ();
			jQuery (t.showLists).html (data ['pvgjData']);
		
			//Call dynamic functions
			t.pvg_editVideos ();
			t.pvg_rmList ();
			t.pvg_rmVideos ();
			t.pvg_addToPage ();
			
			return false;
		});

		t.pvg_EnterKey ();
		t.pvg_createList ();
		return false;
	},
}

var tb_remove = function() {
	jQuery ("#TB_ajaxContent").empty ();

	_tb_remove();
	//jQuery (pvgList.showLists).empty ().html ("Updating...");
	pvgList.pvg_getList ();
};
