var checkStatus = {
	
	selector:  "div.pvg_support img",

    onLine: function ()
    {
    	var t = this;

        jQuery.ajax ({
             url:  ajaxurl,
             type: "POST",
             data: {
                 postCommentNonce: pvgjs.postCommentNonce,
                 action: "pvg_AjaxRetRequesopn",
                 typekey: "pvg_checkStat",
             }
        }).fail (function (){
        	
        	console.log ("...");

        }).done (function (data){

        	if (data == "Online")
        	{
	            var gsrc  = jQuery (t.selector).attr ("src").split ("/");
	            var link  = gsrc.slice (0, -1).join ("/");
	            var image = link+"/skype-online.png"; 

	            jQuery (t.selector).attr ("src", image);
	            return false;
	        }
        });
    },
};

var pvg_galOptions = {

	csbutton: "#pvgCs",
	cgbutton: "#pvgCg",
	showMsg:  "#pvg_opnMsg",
	mainDivs: "div.pvg_styles :input",
	mainDiv:  "div.pvg_options :input",

	//I could of used the same one in the list, but I rather keep
	//things separated since I tend to move stuff around alot.
	opn_showMsg : function (data, status) {
		var t = this;
		var i = 2500;

		jQuery (t.showMsg).addClass ("pvg_message " + status).html (data).fadeIn ("slow");

		if (jQuery (t.showMsg).hasClass ("pvg_message"))
		{
			setTimeout (function (){
				jQuery (t.showMsg).removeClass ().html ("");
			}, i);
		}
	},

	updateCG : function () {
		var t = this;

		t.updateCS ();
		t.colorPicker ();
		t.checkBrokenVids ();

		jQuery (t.cgbutton).on ("click", function ()
		{
			 var val = {};
			 
			 jQuery (".loadermenus").show ();

			 jQuery.each (jQuery(t.mainDiv).serializeArray (), function (i, k) {
			 	val [k.name] = k.value;
			 });

			 jQuery.ajax ({
			 		url: ajaxurl,
			 		type: "POST",
			 		
			 		data: {
			 			postCommentNonce: pvgjs.postCommentNonce,
                     	action: "pvg_AjaxRetRequesopn",
                     	typekey: "pvg_option_cg",
                     	fields: val,}

			 }).fail (function (data){

			 	jQuery (".loadermenus").hide ();
			 	return false;//maybe something later

			 }).done (function (data){

			 	 if (data != null)
			 	 {
			 	 	 t.opn_showMsg (data, "success");
			 	 }
			 	 jQuery (".loadermenus").hide ();
			 });
		});

		return false;
	},

	updateCS : function () {
		
		var t = this;

		jQuery (t.csbutton).on ("click", function ()
		{
			 var val = {};
			 
			 jQuery.each (jQuery(t.mainDiv).serializeArray (), function (i, k) {
			 	val [k.name] = k.value;
			 });

			 jQuery.ajax ({
			 		url: ajaxurl,
			 		type: "POST",
			 		
			 		data: {
			 			postCommentNonce: pvgjs.postCommentNonce,
                     	action: "pvg_AjaxRetRequesopnz",
                     	typekey: "pvg_option_cs",
                     	fields: val,}

			 }).fail (function (){

			 	return ;//maybe something later

			 }).done (function (data){

			 	 if (data != null)
			 	 {
			 	 	 t.opn_showMsg (data, "success");
			 	 }
			 });
		});

		return false;
	},

	colorPicker : function ()
	{
		"use strict";
    	
    	if (typeof jQuery.wp === 'object' && typeof jQuery.wp.wpColorPicker === 'function')
    	{
			jQuery ('#tbbc').wpColorPicker (); //Border
        	jQuery ('#tbtc').wpColorPicker (); //Text
        	jQuery ('#tbth').wpColorPicker (); //Text hover
        	jQuery ('#tbbg').wpColorPicker (); //background

        }else{
	        //We use farbtastic if the WordPress color picker widget doesn't exist
	        jQuery ('#colorpicker').farbtastic ('#tbtc');
	        jQuery ('#colorpicker').farbtastic ('#tbbc');
	        jQuery ('#colorpicker').farbtastic ('#tbth');
	        jQuery ('#colorpicker').farbtastic ('#tbbg');
    	}
	},

	checkBrokenVids : function ()
	{
		jQuery ("#pvgCBk").on ("click", function (e) {
			jQuery ("#message").html ("");
			jQuery (".loaderbroke").show ();
			jQuery ("#pvgCBk").attr("disabled", "disabled");;

			jQuery.ajax ({
			 		url: ajaxurl,
			 		type: "POST",
			 		
			 		data: {
			 			postCommentNonce: pvgjs.postCommentNonce,
                     	action: "pvg_AjaxRetRequesopn",
                     	typekey: "pvg_option_cb",
                    }

			 }).fail (function (data){
			 	jQuery (".loaderbroke").hide ();
			 	return false;

			 }).done (function (data){
					
					var removed = "<strong style='color: limegreen;'>Removed: "+data+"</strong>";

					jQuery (".loaderbroke").hide ();

					if (data == null)
					{
						removed = "<strong style='color: steelblue;'>Everything looks, good!</strong>";
					}
					
					jQuery ("#message").html (removed);
					jQuery ("#pvgCBk").removeAttr ("disabled");
			 });
		});
	}
};


//Dom ready, call functions
//jQuery (document).ready (function ($){
//    pvg_galOptions.updateCG ();
//});
