

var pvgSearch = {

    sval :           null,
    currentP :       1,
    databutton :     "#pvg_ssActionBtn",
    dataSelector :   '#pvg_showVideos',
    dataTextytID :   "#pvg_sActionTxt",  
    dataLoader :     ".loadersearch",
    pagiBttn :       "#pvg_pagiBtn",
    dropDownb :      "#pvg_select",
    pagiclicks :     "[id^=pvg_pagiActionB]",
    loaderIMG :      ".loaderpages",

    //Get videos
    pvg_getPostValue : function ($)
    {
        var t = this;

        t.pvg_SelectedValue ();

        jQuery(t.databutton).on ("click", function (event, extra) 
        {         
            if(extra == undefined) {
                t.currentP = 1;

                jQuery(t.dataLoader).show ();
                jQuery(t.dataSelector).html ("");
            }

            if(t.sval == "") {
                jQuery(t.dataLoader).hide ();
                jQuery(t.dataSelector).html ("Please select a search method");

                return false;
            }

            if(jQuery(t.dataTextytID).val () == "") {
                jQuery(t.dataLoader).hide ();
                jQuery(t.dataSelector).html ("Please enter the youtube id to search for");
                return false;    
            }

            jQuery.ajax ({
                 url:  ajaxurl,
                 type: "POST",
                 data: {
                     postCommentNonce: pvgjs.postCommentNonce,
                     action: "pvg_AjaxRetRequests",
                     searchType: t.sval,
                     pagiInt:   !(extra == undefined)?extra.pagiPpage:0,
                     pagiType:  !(extra == undefined)?extra.pagiType:"", 
                     curPage:   t.currentP,
                     searchID: jQuery(t.dataTextytID).val ()}

            }).fail (function () {
                    console.log ("failed");
                    jQuery(t.dataLoader).hide ();

            }).done (function(data){

                    jQuery(t.dataLoader).hide ();

                    if (data ["pvgjData"] == null) 
                    {
                        jQuery(t.dataSelector).addClass ("pvg_message warning")
                            .html (":( Opps, I can't find any more videos")
                            .show ("fast");

                    }else{

                        if (jQuery(t.dataSelector).hasClass ("pvg_message warning"))
                        {
                            jQuery(t.dataSelector).removeClass ();
                        }

                        jQuery(t.dataLoader).hide ();
                        jQuery (t.dataSelector).html (data ['pvgjData']);

                        t.pvg_Pagi ();

                        pvgList.pvg_addtoList ();
                        checkStatus.onLine ();
                    }
            });
            event.stopPropagation ();
        }); 
    },

    //Allow enterkey on textbox
    pvg_EnterKey : function ()
    {
        var t = this;

        jQuery (t.dataTextytID).keyup (function (e)
        {
            if (e.keyCode == 13) 
            {
                jQuery (t.databutton).trigger ("click");
                return false;
            }
        });
    },

    //Get selected type: author, playlist, video
    pvg_SelectedValue : function () 
    {
        var t = this;

        t.sval = jQuery(t.dropDownb).val ();

        if (!jQuery(t.dropDownb).val () == "")
        {
            jQuery(t.dropDownb).on ("change", function (event) {

                t.sval = jQuery(this).val ();
                event.stopPropagation ();
            });  
        }

        t.pvg_EnterKey ();
    },

    //Pagination
    pvg_Pagi : function ()
    {
        var t = this;

        jQuery(t.loaderIMG).hide ();
        jQuery(t.pagiclicks).on ("click", function (){
            //
            //if (jQuery(this).val () == "Prev")
            //{
            //    t.currentP -= 1;
            //
            //}else{
            //
            //    t.currentP += 1;
            //}

            var data = [{
                pagiPpage: jQuery("#pvg_" + jQuery (this).val()).val (),
                pagiType:  jQuery(this).val(),
                currentP:  t.currentP
            }];

            jQuery(t.databutton).trigger ("click", data);
            jQuery(t.loaderIMG).show ();
        });
    },
};


//Dom ready, call functions
jQuery (document).ready (function ($){
    checkStatus.onLine ();
    pvgSearch.pvg_getPostValue ();
    pvgList.pvg_getList ();
    pvg_galOptions.updateCG ();
});