<?php

 defined ('ABSPATH') or die (); //security 

 if (!class_exists ('pvg_general'))
 {
 	 class pvg_general
 	 {	
 	 	   static $sing;

 	 	   private $wpPages;

 	 	  /**
		   * exclude - used to remove these pages when using
		   * wp > get_pages ();
		   * @var array
		   **/
 	 	   private $exclude = array (
 	 	   		'register', 'login', 'logout',
 	 	   		'lostpassword', 'resetpass',
 	 	   );

 	 	  /**
 	 	   * Check my skype status
 	 	   * If I am only, let user know that I am online
 	 	   * and free to chat
 	 	   * @var string
 	 	   **/
 	 	   public function myStatus ()
 	 	   {
 	 	   	   $status  = ''; 
 	 	   	   $getstat = curl_init ('http://mystatus.skype.com/hexcoderz.txt');
 	 	   	   $curlopn = array (

 	 	   	   		CURLOPT_HEADER   => false,
 	 	   	   		CURLOPT_NOBODY   => false,
 	 	   	   		CURLOPT_TIMEOUT  => 400,
 	 	   	   		CURLOPT_ENCODING => 'gzip',
 	 	   	   		CURLOPT_CONNECTTIMEOUT => 0,
                    CURLOPT_RETURNTRANSFER => true,
 	 	   	   );

 	 	   	   curl_setopt_array ($getstat, $curlopn);

 	 	   	   $status = curl_exec ($getstat);
 	 	   	   $code   = curl_getinfo ($getstat);

 	 	   	   if ($code ['http_code'] == 200) return json_encode ($status);
 	 	   	   curl_close ($getstat);

 	 	   	   return false;
 	 	   }

 	 	  /**
 	 	   * Make sure server has CURL installed
 	 	   * XML functionality will be added soon.
 	 	   * @var string
 	 	   **/
 	 	   public function checkServerDep ()
 	 	   {
 	 	   		if (!function_exists ('curl_init'))
 	 	   	    {
 	 	   	   		echo '<div class="error" style="text-align:center;"><h3>
 	 	   	   				Pleae enable <a href="http://us3.php.net/manual/en/book.curl.php">CURL</a> 
 	 	   	   				to use tihs plugin!, If you can`t enable <a href="http://us3.php.net/manual/en/book.curl.php">CURL</a>
 	 	   	   				, please contact us asap.
 	 	   	   			  </h3></div>';
 	 	   	   			  
 	 	   	   		return false;
 	 	   	    }
 	 	   }

 	 	   public function selectPages ()
 	 	   {
 	 	   		$pages   = $this->getwpPages ();
 	 	   		$scdtag  = pvg_init::pvgsing ()->pvg_getShortCtag ();
 	 	   		$html    = "";
 	 	   		$p_name  = "";

 	 	   		foreach ($pages as $k)
 	 	   		{
 	 	   			$title  = $k->post_title;
 	 	   			$perma  = get_permalink ($k->ID);
 	 	   			$scodes = get_shortcode_regex ();

 	 	   			if (preg_match ('/'.$scodes.'/', $k->post_content, $m) && 
 	 	   				array_key_exists (2, $m) && $scdtag === $m [2]) {

 	 	   				$t = explode ("\" ", str_replace ('"', "", $m [3]));

 	 	   				foreach ($t as $p)
 	 	   				{
 	 	   					preg_match ("/list=([a-zA-Z0-9_\- ]+)/i", $p, $r);

 	 	   					if (isSet ($r [1]))
 	 	   					{
 	 	   						$r [1] = str_replace (" arrange", "", $r [1]);
 	 	   						$r [1] = str_replace (" limit",   "", $r [1]);
 	 	   					
 	 	   						$p_name [$r [1]][] = '<a href="'.$perma.'" alt="" target="_blank">'.$k->post_title.'</a>';
 	 	   					}
 	 	   				}
 	 	   			}

 	 	   			$html .= '<option value="'.$k->ID.'">'.$title.'</option>';
 	 	   		}

 	 	   		$limg = STUBEG_PURL.STUBEG_DEFTHEME;

 	 	   		$data = array (
 	 	   			'p_name' => $p_name,
 	 	   			'loader' => $this->pvg_loaderGIF(),
 	 	   			'html' 	 => '<select name="pvg_wpPages" class="pvgPages">
 	 	   					      <option value=""></option>'.$html.'
 	 	   				         </select>',
 	 	   		);

 	 	   		return $data;
 	 	   }

	       public function pvg_addCodeToPage ()
	       {
	       		$listID = preg_match ('/^[0-9]+$/', $_POST ['listid'])?$_POST ['listid']:false;
	       		$pageID = preg_match ('/^[0-9]+$/', $_POST ['pageid'])?$_POST ['pageid']:false;
	       		$scdtag = pvg_init::pvgsing ()->pvg_getShortCtag ();

	       		if ($listID == false) return false;
	       		if ($pageID == false) return false;

	       		$pageData = get_post ($pageID);
            	$checkID  = pvg_list::pvglsing ()->pvg_checkCatID ($listID);

            	if ($checkID)
            	{
            		$cdata   = $pageData->post_content;
            		$newcode = '['.$scdtag. ' list="'.$checkID.'"]';
            		$linebr  = (!empty ($cdata))?"<br/>":"";
            		$content = $cdata.$linebr.$newcode;

            		if (in_array ($pageData->post_name, $this->exclude)) return false;

            		if (preg_match ("/\[{$scdtag}\slist=(.*)\]/", $cdata))
            		{
            			$cdata   = preg_replace("/\[{$scdtag}\slist=(.*)\]/", $newcode, $cdata); 
            			$content = $cdata; 
            		}

	                $upage = array ('ID' => $pageData->ID, 'post_content' => $content);
	           
	                wp_update_post ($upage);
	                
	                //this will be removed to a message class later.
	                $msg = array (
	                	'code' => 0, 'msg' => 'Shortcode added to page'
	                );

	                return json_encode (array ('pvgjMSG' => $msg));
		            
	            }
		        return false;
	       }

 	 	   public function getwpPages ()
 	 	   {
 	 	   		$args = array(
					'sort_order'  => 'ASC',
					'sort_column' => 'post_title',
				);

 	 	   		//Remove the following pages from array.
 	 	   		$exclude = array (
 	 	   			'register', 'login', 'logout',
 	 	   			'lostpassword', 'resetpass',
 	 	   		);

 	 	   		$pages = get_pages ($args);

				if (!empty ($pages))
				{
					foreach ($pages as $k)
					{
						if (!in_array ($k->post_name, $this->exclude))
						{
							$this->wpPages [] = $k;
						}
					} return $this->wpPages;
				}
				return false;
 	 	   }

 	 	   public function pvg_loaderGIF ()
 	 	   {
 	 	   		return "<i class='spinner' style='display:inline-block;float:none' alt='loading...'></i>";
 	 	   }

 	 	   public function pvg_sortBy ($a,  $i)
 	 	   {
				$b[] = $a ['udate'] - $i ['udate'];
 	 	   }

 	 	   //Singleton.
 	 	   public static function gsing ()
 	 	   {
 	 	   		is_null (self::$sing) && self::$sing = new self;
            	return self::$sing;
 	 	   }
 	 }
 }