<?php

/***********************************************/
/*** Just a quick and dirty template parser  ***/
/***********************************************/

if (!class_exists ("pvg_template"))
{
	class pvg_template
	{
		protected $templateDir;
		protected $templateFile; 
		protected $templateVars  = array ();

		public function __construct ($dir)
		{
			if (!is_dir ($dir)) 
			{
				 throw new Exception ("$dir no such file or directory", 1);
		    }
			$this->templateDir = $dir;
		}

		public function pvgRenderTemplate ($file)
		{
			if (!is_readable ($this->templateDir.$file))
		   	{
		   		throw new Exception ("$this->templateDir.$file File is not readable", 1);	
		   	}

		   	$this->templateFile = $file;
		}

		public function pvgOutputTplView ()
		{
			$bufferData = "";

			ob_start ();

			$this->templateVars ['pvg_loader'] = pvg_general::gsing ()->pvg_loaderGIF ();			
			
			if (!empty ($this->templateVars))
		 	{  
				 extract ($this->templateVars);
			}

			include $this->templateDir.$this->templateFile;
			
			$bufferData = ob_get_clean ();
			
			return  $bufferData;
		}

		public function __get ($p)
		{
			 if (array_key_exists ($p, $this->templateVars))
			 {
			 	 return $this->templateVars [$p];
			 }
		}

		public function __set ($p, $v)
		{
			$this->templateVars [$p] = $v;
		}

		public function __isset ($p)
		{
			return isSet ($this->templateVars [$p]);
		}

		public function __unset ($p)
		{
			unset ($this->templateVars [$p]);
		}
	}
}
?>