<?php

/********************************************************/
/*** Validate submition - Uncompleted                 ***/
/*** @func validateType: Validate request i.e: post   ***/
/*** @valite: Return types for validation             ***/
/*** @validateStr: Check string (yt id)               ***/
/*** @validateNonce: Check sites Nonce                ***/
/*** Some of these functions are mostly not needed    ***/
/*** but you know what? NO ONE is going to get hacked ***/
/*** just because I missed something, so I rahter     ***/
/*** validate to keep your site secure.               ***/
/********************************************************/
    
if (!class_exists ("pvg_validator"))
{
     class pvg_validator 
     {    
        private static $init = null;
        
        public static function validateType ($ty_str, $validate = NULL)
        {
            $render = NULL;
            
            if (!empty ($ty_str) && array_key_exists ($ty_str, $validate))
            {
                $render = array (0 => $ty_str,); //later use);
            }
            return $render;
        }
        
        public static function validateStr ($str = NULL)
        {
            return empty ($str)?"":strip_tags($str);
        }
        
        public static function validateNonce ($nonce)
        {
            if  (!wp_verify_nonce ($nonce, 'pvg-post-nonce')) {
                 echo __ ('She went that way >>> 404.');
                 exit;
            }
        }
        
        public static function validateName ($str)
        {
            if (strlen ($str) >= 15) return false;
            if (!preg_match ('@(^[a-z]+)([\- \w]*)([a-z0-9])$@i', "$str")) return false;
            return true;
        }

        public static function initialize ()
        {
            is_null(self::$init) && self::$init == new self;
            return self::$init;
        }
     }
}