

 onYouTubeIframeAPIReady = function (data)
 {
      if (typeof YT.Player == "undefined") return false;
      if (typeof data == "undefined") return false;

      player = new YT.Player ("player", {
          videoId: data.mv, 
          width:  '100%', height: '100%',
          playerVars: {
            'autohide': 1, 'wmode': 'opaque', 'theme': data.tm, vq: "hd720",
            'enablejsapi': 1, 'modestbranding': data.md, 'iv_load_policy': 3, 'rel': 0,
          },

          events: {
              'onReady': ytJS.onPlayerReady,
              'onStateChange': ytJS.onPlayerStateChange
          }
      });
 }

 var ytJS = { 

    playlist:  "",
    preview:   ".pvg_preview",
    justhumb:  ".pvg_useBox",
    autoplay:  false,
    params:    "",
    origin:    window.location.protocol+"//"+window.location.host,

    loadPlayer: function ($)
    {
       if (typeof jQuery ("#opn").attr ("name") != "undefined")
       {
          ytJS.params = JSON.parse (jQuery ("#opn").attr ("name"));

	        if (ytJS.params.ap == 1) ytJS.autoplay = true;

	        if (ytJS.params.cn.length > 0)
          {
            	ytJS.playlist = JSON.parse (ytJS.params.cn);
          }

          if (ytJS.params.mb == 1)
          {
          		ytJS.createMobileIframe ();
          		ytJS.thumbActions ($);
          }

          if ($("#player").length >= 1 && ytJS.params.mb == 0)
	        {
              	onYouTubeIframeAPIReady (ytJS.params);
              	ytJS.thumbActions ($); 

     	    }else{

      	        ytJS.onlyThumbs ($);
      	    }
       }

       $(".pvg_usePopUp").bind ("click", function (){

          var id = jQuery (this).attr ("id");
          var w = ytJS.params.wt,
              h = ytJS.params.ht;

          var left = (screen.width - w) / 2,
              top  = (screen.height - h )/ 2;

          var yturl = 'http://youtube.com/embed/'+id+'?rel=0&autoplay=1';
          var winsz = 'width='+w+', height='+h,
              winft = 'menubar=no, location=no, resizable=yes, scrollbars=no, status=no, toolbar=no, directories=no, copyhistory=no';

          var win = window.open (
            'about:blank', "Get Playlist Video Gallery at codecanyon.net",
            winsz+winft
          );

          win.location.href = yturl;

          win.resizeTo (w, h);
          win.moveTo (left, top);
          //win.document.body.innerHTML = "<iframe frameborder='0' id='player' src='"+yturl+"' width=100% height=100% style='padding: 0px; margin: 0px;'></iframe>";
          win.focus ();
       });

     	// return false;
    },

    onlyThumbs: function ($)
    {
	  	jQuery (ytJS.justhumb).on ("click", function (e){
            e.stopImmediatePropagation ();

            var id  = jQuery (this).attr ("id");
            var ccw = ytJS.params.wt;
            var cch = ytJS.params.ht;
            var ifr = "<div id='player' style='height: 100%; width: 100%;'></div>";

            ytJS.autoplay  = true;
            ytJS.params.mv = id;

            $.colorbox ({
                transition: "elastic",
                inline: true, href: ifr, opacity: 0.80, scrolling: false,
                innerHeight: cch, innerWidth: ccw, fastIframe: false,
            });

            ytJS.params.inx = ytJS.playlist.indexOf (id);
            onYouTubeIframeAPIReady (ytJS.params);
      	});

  	},



    thumbActions: function ()
    {
  		jQuery (ytJS.preview).on ("click", function (e){
        e.preventDefault();

    		var parent = this;
      		ytJS.autoplay   = true;
      		ytJS.params.mv  = jQuery (parent).attr ("id"); 

	    	jQuery ("html, body").animate ({

	            scrollTop: jQuery (".pvg_iframe").offset ().top - 60

	      	}, 950, function (e){

	            ytJS.params.inx = ytJS.playlist.indexOf (ytJS.params.mv);	      	

	            if (ytJS.playlist.length >= 1 && ytJS.params.mb == 0)
              {
	                player.loadPlaylist (ytJS.playlist, ytJS.params.inx, 0, "hd720");
              }

	            if (ytJS.params.mb == 0) player.playVideo();
	            if (ytJS.params.mb == 1) ytJS.createMobileIframe ();

	            if (ytJS.playlist.length <= 0 && ytJS.params.mb == 0) 
	                player.loadVideoById (ytJS.params.mv, 0, "hd720");
	        }); 
        }); 
    },

    onPlayerStateChange: function (event)
    {
    	 return; //later use
    },

    onPlayerReady: function (event)
    {
  		  if (ytJS.playlist.length > 0 && ytJS.params.mb == 0)
      	{
        	 player.cuePlaylist (ytJS.playlist, ytJS.params.inx, 0, "hd720");

           if (ytJS.autoplay === true)
           {
                player.loadPlaylist (ytJS.playlist, ytJS.params.inx, 0, "hd720");
           }
      	}

      	if (ytJS.autoplay === true) 
      	{
          	event.target.playVideo();
      	}
    },

 	  createMobileIframe: function ()
    {
  		jQuery ("#player").html ("");

  		var ytlink = "http://www.youtube.com/embed/"+ytJS.params.mv+
  					 "?origin="+ytJS.origin+"&html5=1&enablejsapi=1&html5=1&playerapiid=player&version=2&autoplay=1";
  		var iframe = "<iframe id='player' frameborder='0' src='"+ytlink+"' seamless allowfullscreen></iframe>"

  		jQuery ("#player").html (iframe);

  		return false;
    },

      //right now I don't need this.

    setProperties: function ()
    { 
        ytJS.ytEle.src = "https://www.youtube.com/iframe_api";
        ytJS.ytSTag.parentNode.insertBefore (ytJS.ytEle, ytJS.ytSTag);
    }
 }

 jQuery ("document").ready (function ($) {
  	window.onload = function () {ytJS.loadPlayer ($);}

  	jQuery('.pvg_thumbnails').css({
        top : (jQuery(window).height() - $('.pvg_thumbnails').outerHeight ()) / 2
  	});

  	jQuery(window).resize(function() {
        jQuery('.pvg_thumbnails').css({
            top : (jQuery(window).height() - $('.pvg_thumbnails').outerHeight ()) / 2
        });
  	});
 });

